/*
	EzGraph-Win32
	Ver0.20
	2013.03.15
	Kazuhiko Ohno
*/

#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<ctype.h>
#include<string.h>
#include<windows.h>
#include<shlwapi.h>
#include"EzGraph.h"

#define LIBNAME "EzGraph-Win32"
#define MAJOR_VERSION 0
#define MINOR_VERSION 20

#define LOG_FILENAME "EzGraph.log"
#define INI_FILENAME "EzGraph.ini"
#define INF_FILENAME "EzGraph.inf"

#define XPM_COLOR_MAX 65546
#define XPM_CHR_LEN_MAX 2
// XPM
#ifdef _EZ_COMBINED_BMP
#define XPM_BMP_MAX_DEFAULT 128
#define COMBINED_BMP_SIZE_DEFAULT 128
// COMBINED_BMP_SIZEBMP̍A
// vꂽ摜TCY~̑傫ȏȂA
// COMBINED_BMP𐶐
// ꖢȂAvTCYBMP𐶐
#define COMBINED_BMP_THRESHOLD 2
#else
//#define XPM_BMP_MAX 4096
#define XPM_BMP_MAX_DEFAULT 5000
#endif



// printf()ŏo͂łő啶
#define PRINTF_MAX_LEN 8192


#define InitFill()	    HBRUSH hbrush, hbrush_old; 
#if 1
#define BeginFill()	    hbrush = CreateSolidBrush(pen_color); \
                        hbrush_old = SelectObject(hdc, hbrush); 
#define EndFill()	    SelectObject(hdc, hbrush_old); \
						DeleteObject(hbrush);
#else
#define BeginFill()    
#define EndFill()      
#endif

typedef struct {
	int key;
	int flag;
	int is_down;
} event_key_t;

typedef struct {
	int x;
	int y;
	unsigned int button;
	int flag;
} event_mouse_t;

// L[͏

// WindowszL[ł̏󋵃}bv
char vk_map[32] = {0};


typedef struct {
	unsigned short nonshifted;
	unsigned short shifted;
} key2chr_t;

typedef struct {
	unsigned char vk;
	unsigned short ezk;
	key2chr_t chr;
} vk2ezk_t;

vk2ezk_t vk2ezk[] = {
    {VK_LMENU,    EZ_Alt_L,     {EZ_Alt_L,     EZ_Alt_L}},     // 12 ȂH
    {VK_RMENU,    EZ_Alt_R,     {EZ_Alt_R,     EZ_Alt_R}},     // 12 ȂH
  
    {VK_BACK,     EZ_BackSpace, {0x08,         0x08}},         // 08
    {VK_TAB,      EZ_Tab,       {0x09,         0x09}},         // 09
    {VK_RETURN,   EZ_Return,    {0x0d,         0x0d}},         // 0D
    {VK_LSHIFT,   EZ_Shift_L,   {EZ_Shift_L,   EZ_Shift_L}},   // 10
    {VK_RSHIFT,   EZ_Shift_R,   {EZ_Shift_R,   EZ_Shift_R}},   // 10
    {VK_LCONTROL, EZ_Control_L, {EZ_Control_L, EZ_Control_L}}, // 11
    {VK_RCONTROL, EZ_Control_R, {EZ_Control_R, EZ_Control_R}}, // 11
    {VK_ESCAPE,   EZ_Escape,    {0x1b,     0x1b}},             // 1B
    {VK_SPACE,    EZ_space,     {' ',      ' '}},              // 20
	{VK_PRIOR,    EZ_Page_Up,   {EZ_Page_Up,   EZ_Page_Up}},   // 21 
	{VK_NEXT,     EZ_Page_Down, {EZ_Page_Down, EZ_Page_Down}}, // 22
	{VK_END,      EZ_End,       {EZ_End,       EZ_End}},       // 23
	{VK_HOME,     EZ_Home,      {EZ_Home,      EZ_Home}},      // 24 
	{VK_LEFT,     EZ_Left,      {EZ_Left,      EZ_Left}},      // 25 
	{VK_UP,       EZ_Up,        {EZ_Up,        EZ_Up}},        // 26
	{VK_RIGHT,    EZ_Right,     {EZ_Right,     EZ_Right}},     // 27
	{VK_DOWN,     EZ_Down,      {EZ_Down,      EZ_Down}},	   // 28
	{VK_INSERT,   EZ_Insert,    {EZ_Insert,    EZ_Insert}},	   // 2d
	{VK_DELETE,   EZ_Delete,    {0x7f,         0x7f}},	       // 2e

	{0x30,      EZ_0,      {'0',      0}},            // 30
	{0x31,      EZ_1,      {'1',      '!'}},          // 31
	{0x32,      EZ_2,      {'2',      '"'}},          // 32
	{0x33,      EZ_3,      {'3',      '#'}},          // 33
	{0x34,      EZ_4,      {'4',      '$'}},          // 34
	{0x35,      EZ_5,      {'5',      '%'}},          // 35
	{0x36,      EZ_6,      {'6',      '&'}},          // 36
	{0x37,      EZ_7,      {'7',      '\''}},         // 37
	{0x38,      EZ_8,      {'8',      '('}},          // 38
	{0x39,      EZ_9,      {'9',      ')'}},          // 39

	{0x41,      EZ_A,      {'a',      'A'}},          // 41
	{0x42,      EZ_B,      {'b',      'B'}},          // 42
	{0x43,      EZ_C,      {'c',      'C'}},          // 43
	{0x44,      EZ_D,      {'d',      'D'}},          // 44
	{0x45,      EZ_E,      {'e',      'E'}},          // 45
	{0x46,      EZ_F,      {'f',      'F'}},          // 46
	{0x47,      EZ_G,      {'g',      'G'}},          // 47
	{0x48,      EZ_H,      {'h',      'H'}},          // 48
	{0x49,      EZ_I,      {'i',      'I'}},          // 49
	{0x4a,      EZ_J,      {'j',      'J'}},          // 4a
	{0x4b,      EZ_K,      {'k',      'K'}},          // 4b
	{0x4c,      EZ_L,      {'l',      'L'}},          // 4c
	{0x4d,      EZ_M,      {'m',      'M'}},          // 4d
	{0x4e,      EZ_N,      {'n',      'N'}},          // 4e
	{0x4f,      EZ_O,      {'o',      'O'}},          // 4f
	{0x50,      EZ_P,      {'p',      'P'}},          // 50
	{0x51,      EZ_Q,      {'q',      'Q'}},          // 51
	{0x52,      EZ_R,      {'r',      'R'}},          // 52
	{0x53,      EZ_S,      {'s',      'S'}},          // 53
	{0x54,      EZ_T,      {'t',      'T'}},          // 54
	{0x55,      EZ_U,      {'u',      'U'}},          // 55
	{0x56,      EZ_V,      {'v',      'V'}},          // 56
	{0x57,      EZ_W,      {'w',      'W'}},          // 57
	{0x58,      EZ_X,      {'x',      'X'}},          // 58
	{0x59,      EZ_Y,      {'y',      'Y'}},          // 59
	{0x5a,      EZ_Z,      {'z',      'Z'}},          // 5a
    {VK_NUMPAD0,	EZ_KP_0,      {'0',      0xff9e}},     // 60
    {VK_NUMPAD1,    EZ_KP_1,      {'1',      0xff9c}},     // 61
    {VK_NUMPAD2,    EZ_KP_2,      {'2',      0xff99}},     // 62
    {VK_NUMPAD3,    EZ_KP_3,      {'3',      0xff9b}},     // 63
    {VK_NUMPAD4,    EZ_KP_4,      {'4',      0xff96}},     // 64
    {VK_NUMPAD5,    EZ_KP_5,      {'5',      0xff9d}},     // 65
    {VK_NUMPAD6,    EZ_KP_6,      {'6',      0xff98}},     // 66
    {VK_NUMPAD7,    EZ_KP_7,      {'7',      0xff95}},     // 67
    {VK_NUMPAD8,    EZ_KP_8,      {'8',      0xff97}},     // 68
    {VK_NUMPAD9,    EZ_KP_9,      {'9',      0xff9a}},     // 69

    {VK_MULTIPLY,   EZ_KP_Multiply,  {'*',     '*'}},    // 6a
    {VK_ADD,        EZ_KP_Add,       {'+',     '+'}},    // 6b
    {VK_SEPARATOR,  EZ_KP_Separator, {',',     0}},      // 6c  L[݂Ȃ̂œ얢mF
    {VK_SUBTRACT,   EZ_KP_Subtract,  {'-',     '-'}},    // 6d
    {VK_DECIMAL,    EZ_KP_Decimal,   {'.',     0xff9f}}, // 6e
    {VK_DIVIDE,     EZ_KP_Divide,    {'/',     '/'}},    // 6f

    {VK_F1,     EZ_F1,     {EZ_F1,    EZ_F1}},        // 70
	{VK_F2,     EZ_F2,     {EZ_F2,    EZ_F2}},        // 71
	{VK_F3,     EZ_F3,     {EZ_F3,    EZ_F3}},        // 72
	{VK_F4,     EZ_F4,     {EZ_F4,    EZ_F4}},        // 73
	{VK_F5,     EZ_F5,     {EZ_F5,    EZ_F5}},        // 74
	{VK_F6,     EZ_F6,     {EZ_F6,    EZ_F6}},        // 75
	{VK_F7,     EZ_F7,     {EZ_F7,    EZ_F7}},        // 76
	{VK_F8,     EZ_F8,     {EZ_F8,    EZ_F8}},        // 77
	{VK_F9,     EZ_F9,     {EZ_F9,    EZ_F9}},        // 78
    {VK_F10,    EZ_F10,    {EZ_F10,   EZ_F10}},       // 79  WindowsŃj[Ɋ蓖ĂĂ邽ߔȂH
    {VK_F11,    EZ_F11,    {EZ_F11,   EZ_F11}},       // 7a
    {VK_F12,    EZ_F12,    {EZ_F12,   EZ_F12}},            // 7b
    {VK_OEM_1,      EZ_colon,     {':',      '*'}},       // ba
    {VK_OEM_PLUS,   EZ_semicolon, {';',      '+'}},       // bb
    {VK_OEM_COMMA,  EZ_comma,     {',',      '<'}},       // bc
    {VK_OEM_MINUS,  EZ_minus,     {'-',      '='}},       // bd
    {VK_OEM_PERIOD, EZ_period,    {'.',      '>'}},       // be
    {VK_OEM_2,      EZ_slash,     {'/',      '?'}},       // bf
    {VK_OEM_3,      EZ_at,        {'@',      '`'}},       // c0
    {VK_OEM_4,      EZ_bracketleft,          {'[', '{'}},  // db
	{VK_OEM_5,      EZ_backslash,         {'\\', '|'}}, // dc
    {VK_OEM_6,      EZ_bracketright,          {']', '}'}}, // dd
	{VK_OEM_7,      EZ_asciicircum,         {'^', '~'}}, // de
	{VK_OEM_8,      EZ_underscore,         {'\\', '_'}}, // df
	{VK_OEM_102,    EZ_underscore,         {'\\', '_'}}, // e2
};
#define VK2EZK_NUM (sizeof(vk2ezk)/sizeof(vk2ezk_t))
vk2ezk_t ezk_alias[] = {
	{0x31,      EZ_exclam,     {0, 0}},          // 31
	{0x32,      EZ_quotedbl,   {0, 0}},          // 32
	{0x33,      EZ_numbersign, {0, 0}},          // 33
	{0x34,      EZ_dollar,     {0, 0}},          // 34
	{0x35,      EZ_percent,    {0, 0}},          // 35
	{0x36,      EZ_ampersand,  {0, 0}},          // 36
	{0x37,      EZ_apostrophe, {0, 0}},          // 37
//	{0x37,      EZ_quoteright, {0, 0}},          // apostropheƓEZlȂ̂œo^sv
	{0x38,      EZ_parenleft,  {0, 0}},          // 38
	{0x39,      EZ_parenright, {0, 0}},          // 39
    {VK_OEM_1,      EZ_asterisk, {0, 0}},          // ba
    {VK_OEM_PLUS,   EZ_plus,     {0, 0}},          // bb
    {VK_OEM_COMMA,  EZ_less,     {0, 0}},          // bc
    {VK_OEM_MINUS,  EZ_equal,    {0, 0}},          // bd
    {VK_OEM_PERIOD, EZ_greater,  {0, 0}},          // be
    {VK_OEM_2,      EZ_question, {0, 0}},          // bf
    {VK_OEM_3,      EZ_grave,    {0, 0}},          // c0
//  {VK_OEM_3,      EZ_quoteleft,  {0, 0}},          // graveƓEZlȂ̂œo^sv
};
#define EZK_ALIAS_NUM (sizeof(ezk_alias)/sizeof(vk2ezk_t))


unsigned short vk2ezk_table[0x100];
key2chr_t vk2chr_table[0x100];
unsigned char ezk2vk_table[0x10000];




#if 0



#define EZ_Caps_Lock  0xffe5  /* Caps lock */
#define EZ_Shift_Lock 0xffe6  /* Shift lock */
#define EZ_Meta_L     0xffe7  /* Left meta */
#define EZ_Meta_R     0xffe8  /* Right meta */
#define EZ_Alt_L      0xffe9  /* Left alt */
#define EZ_Alt_R      0xffea  /* Right alt */



	{VK_BACK, EZ_BackSpace}, // 08
	{VK_TAB, EZ_Tab},        // 09
{VK_LSHIFT, EZ_Shift_L},     // 10
{VK_RSHIFT, EZ_Shift_R},     // 10
{VK_LCONTROL, EZ_Control_L}, // 11
{VK_RCONTROL, EZ_Control_R}, // 11



// {VK_END, EZ_}, // 23 END EZ_End͂ȂH




{0x3d, 0x3d},
{0x5c, 0x5c},
{0x5f, 0x5f},
	// eL[EtL[ƂɐL[EZ_0-EZ_9Ƃ݂Ȃ
	{VK_NUMPAD0,EZ_0},       // 60
	{VK_NUMPAD1,EZ_1},       // 61
	{VK_NUMPAD2,EZ_2},       // 62
	{VK_NUMPAD3,EZ_3},       // 63
	{VK_NUMPAD4,EZ_4},       // 64
	{VK_NUMPAD5,EZ_5},       // 65
	{VK_NUMPAD6,EZ_6},       // 66
	{VK_NUMPAD7,EZ_7},       // 67
	{VK_NUMPAD8,EZ_8},       // 68
	{VK_NUMPAD9,EZ_9},       // 69

#endif


#define EVENT_QUEUE_SIZE 16

event_key_t event_key_queue[EVENT_QUEUE_SIZE];
int event_key_queue_head = 0;
int event_key_queue_tail = 0;
static int is_shift_down = 0;
static int is_control_down = 0;
static int is_alt_down = 0;
int prev_wparam = 0;

event_mouse_t event_mouse = {0, 0, 0, 0};
event_mouse_t event_mouse_release = {0, 0, 0, 0};

// COLORREFBGȐȂ̂ŁÃ}Nŕϊ
#define RGB2COLORREF(rgb) (((rgb) & 0xff) << 16) + ((rgb) & 0xff00) + (((rgb) & 0xff0000) >> 16)


// CEBhẼnhێp
HWND win_hwnd = NULL;
HDC win_hdc = NULL;
COLORREF pen_color;

// `ΏۃReLXg
//HDC draw_hdc = NULL;
// 
HDC buf_hdc[2] = {NULL, NULL};
HBITMAP buf_bmp[2] = {NULL, NULL};
int onScreen = 0, offScreen = 1;

int client_width = EzDefaultWidth;
int client_height = EzDefaultHeight;
int fontSize = EzDefaultFontSize;


DWORD timerh_nexttime = 0;
EzTimerHandler timerh_func = NULL;
unsigned long timerh_ms = 1000;
EzKeyHandler keyh_func = NULL;
EzKeyHandler key_releaseh_func = NULL;
EzMouseHandler mouseh_func = NULL;
EzMouseHandler mouse_releaseh_func = NULL;

// EzShowBuffer^ɂȂAWM_PAINTŋUɖ߂
//int showBufferF = 0;

//// EzExitEventLoop()Ő^ɂȂAEventLoop𔲂
//int exitF = 0;
// ^ȂEBhE邩ǂmF_CAOo
int confirmF = -1;
// 0ȂBȂ֐łxItCrbg}bvɂ
//int forceOffline = -1;
//int forceOffline = 0;

extern _EzName2RGB_t _EzName2RGB[];
int name2rgb_num = 0;




#define PI 3.14159265359

// AdjustWindowRectCreateWindowƓX^CKvȂ̂ŁAŃ}NĂ
// TCYύX֎~̂߁AWS_THICKFRAMEO
// ő剻֎~̂߁AWS_MAXIMIZEBOXO
#define WINDOW_STYLE (WS_OVERLAPPEDWINDOW & (~WS_THICKFRAME) & (~WS_MAXIMIZEBOX))

LOGFONT logFont;


HMENU mainMenu, viewMenu, infoMenu;

typedef enum {
	mid_quit,
	mid_view,
	mid_console,
	mid_magnify,
	mid_manual,
	mid_version,
    mid_sysinfo,
} mid_t;

// WinMainŃ[Umain֐Ăяo߁Avg^Cv錾Ă
int main();
void _EzCmdLine2Argv(char *cmdline, char *argv[], int *argc);

int _EzDrawPoint(HDC hdc, int x, int y);
int _EzDrawLine(HDC hdc, int x1, int y1, int x2, int y2);
int _EzDrawString(HDC hdc, int x, int y, char *s);
int _EzDrawBox(HDC hdc, int x1, int y1, int x2, int y2);
int _EzFillBox(HDC hdc, int x1, int y1, int x2, int y2);
int _EzDrawCircle(HDC hdc, int x, int y, unsigned int r);
int _EzFillCircle(HDC hdc, int x, int y, unsigned int r);
int _EzDrawArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2);
int _EzFillArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2);
void _conv_arc_param(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2,
					 int *left, int *top, int *right, int *bottom, int *sx, int *sy, int *ex, int *ey);
int _EzClear(HDC hdc);
int _EzFillPolygon(HDC hdc, int num, int *poly);
void _EzPut(HDC hdc, int x, int y, EzImage img);

int _EzLog(const char *msg);
int _EzWarn(char *fmt, ...);
void _EzError(char *fmt, ...);
void _EzProcessKeyDown(WPARAM wparam);
void _EzProcessKeyUp(WPARAM wparam);
WPARAM _EzCheckModKey(WPARAM wparam);
int _EzEnqueueKeyEvent(int key, int is_down);

char exeDir[MAX_PATH];

LRESULT CALLBACK WindowProc(HWND,UINT,WPARAM,LPARAM);

void _EzSetMenuInfoCheck(HMENU hmenu, UINT item, int flag);
void _EzSetMenuInfoEnable(HMENU hmenu, UINT item, int flag);

int enableMagnify = 0;
void _EzToggleMagnify(void);

// R\[֌W
int enableConsole = 0;
HWND consoleHwnd = NULL;
#define CONSOLE_LINES 25
#define CONSOLE_LENGTH 80
#define CONSOLE_FONTSIZE 14
#define CONSOLE_MARGIN 4
#define CONSOLE_WIDTH (CONSOLE_FONTSIZE * CONSOLE_LENGTH / 2 + CONSOLE_MARGIN*2)
#define CONSOLE_HEIGHT (CONSOLE_FONTSIZE * CONSOLE_LINES + CONSOLE_MARGIN*2)
#define CONSOLE_DWEXSTYLE (WS_EX_LEFT)
#define CONSOLE_DWSTYLE (WS_CAPTION | WS_DLGFRAME | WS_VISIBLE)
void _EzTerminate(void);
void _EzCreateConsole(void);
void _EzDestroyConsole(void);
LRESULT CALLBACK ConsoleProc(HWND,UINT,WPARAM,LPARAM);
int _EzPrintf(const char *fmt, ...);
int _EzPuts(const char *s);
int _EzPutLine(char *s);
char console_text[CONSOLE_LINES][CONSOLE_LENGTH+1];
int console_tail = 0;
// console_tailsɏĂ镶
// ꂪ1ȏ̏ꍇA܂p
// OŉsĂ΁Aconsole_tails͐VKsconsole_len==0
int console_len = 0;
LOGFONT consoleFont;

// _CAO֌W
HWND dialogHwnd = NULL;
EzTimerHandler dialog_timerh_func = NULL;
#define DIALOG_FONTSIZE 24
#define DIALOG_LINEPITCH 24
#define VERSION_CAPTION "o[W"
#define VERSION_WIDTH   300
#define VERSION_HEIGHT  240
#define SYSINFO_CAPTION "VXe"
#define SYSINFO_WIDTH   300
#define SYSINFO_HEIGHT  240
#define DIALOG_DWEXSTYLE (WS_EX_LEFT)
#define DIALOG_DWSTYLE (WS_CAPTION | WS_BORDER | WS_VISIBLE)
LRESULT CALLBACK DialogProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam);

char *applicationName;
char *applicationVendor;
char *applicationVersion;

char *applicationManual;

// XPM֌W
#define XpmChar2ColNo(c1, c2)   (c1 * 0x080 + c2)
typedef struct {
	HBITMAP bmp;
	HBITMAP mask;
#ifdef _EZ_COMBINED_BMP
	int width;
	int currentHeight;
#endif
} xpm_bmp_t;
#ifdef _EZ_COMBINED_BMP
int enable_combined_bmp = 1;
int combined_bmp_size = COMBINED_BMP_SIZE_DEFAULT;
#endif
int xpm_bmp_max = XPM_BMP_MAX_DEFAULT;
xpm_bmp_t *xpm_bmps;
int xpm_bmp_num = 0;

void _EzXPMInitialize(void);
void _EzXPMTerminate(void);
void _EzDeleteImage(void);


#define INI_SECTION_MAX 4
#define INI_NAME_LEN_MAX 16
#define INI_ENTRY_MAX 16
#define INI_VALUE_LEN_MAX 1024
#define INI_BUF_SIZE (INI_NAME_LEN_MAX+INI_VALUE_LEN_MAX+256)

typedef struct {
	char key[INI_NAME_LEN_MAX];
	char value[INI_VALUE_LEN_MAX];
	int is_saved;
} ini_entry_t;
typedef struct {
	char name[INI_NAME_LEN_MAX];
	ini_entry_t entries[INI_ENTRY_MAX];
	int entry_num;
	int saved_entry_num;
} ini_section_t;

ini_section_t ini_sections[INI_SECTION_MAX];
int ini_section_num = 0;

void _EzSetWindowSize(int width, int height);

void _EzSaveStat(void);
void _EzLoadIni(void);
void _EzLoadInf(void);
void _EzLoadIniFile(char *path, int is_saved);
void _EzSaveIni(void);
int _EzReadIniInt(char *section_name, char *key, int default_value);
int _EzReadIniBool(char *section_name, char *key, int default_value);
char *_EzReadIniString(char *section_name, char *key, char *default_value);
char *_EzReadIniEntry(ini_section_t *section, char *key, char *default_value);
void _EzWriteIniInt(char *section_name, char *key, int value);
void _EzWriteIniIntNosave(char *section_name, char *key, int value);
void _EzWriteIniBool(char *section_name, char *key, int value);
void _EzWriteIniBoolNosave(char *section_name, char *key, int value);
void _EzWriteIniString(char *section_name, char *key, char *value);
void _EzWriteIniStringNosave(char *section_name, char *key, char *value);
void _EzWriteIniEntry(ini_section_t *section, char *key, char *value, int is_saved);
ini_section_t *_EzGetIniSection(char *name);
ini_section_t *_EzCreateIniSection(char *name);
ini_entry_t *_EzGetIniEntry(ini_section_t *section, char *key);
ini_entry_t *_EzCreateIniEntry(ini_section_t *section, char *key);
void _EzShowManual(void);
void _EzShowVersion(void);
void _EzDrawVersion(HDC hdc, int width, int height);
void _EzShowSysInfo(void);
void _EzDrawSysInfo(HDC hdc, int width, int height);
void _EzOpenModalWindow(int left, int top, int width, int height,
						void(*draw_func)(HDC hdc, int width, int height), char *caption);


int WINAPI WinMain(HINSTANCE hInstance,
		   HINSTANCE hPrevInstance,
		   LPSTR lpCmdLine,
		   int nShowCmd)
{
    HWND hwnd;
	WNDCLASSEX wc;
//	HBRUSH hBrush;
//    HMENU mainMenu;
	char exePath[MAX_PATH];
	char *exeFile;
	char *argv[ARG_MAX];
    int argc;
	int i;
	char *p;
	int left, top;

	wc.cbSize = sizeof(WNDCLASSEX);
    // EBhEDC̑iIɂ邽OWNDCw
	wc.style = CS_OWNDC;
    wc.lpfnWndProc = WindowProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground=(HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName =NULL;
    wc.lpszClassName="EzGraphWin32Class";
	wc.hIconSm = NULL;    
	if (RegisterClassEx(&wc) == 0){
        return 0;
	}

	hwnd = CreateWindowEx(WS_EX_APPWINDOW, wc.lpszClassName, "EzGraph-Win32", WINDOW_STYLE,
		      100, 100, client_width, client_height, NULL, NULL, hInstance, NULL);

    if (hwnd == NULL)
        return 0;
	win_hwnd = hwnd;

	// ConsoleEBhENX
	wc.cbSize = sizeof(WNDCLASSEX);
    // EBhEDC̑iIɂ邽OWNDCw
	wc.style = CS_OWNDC;
    wc.lpfnWndProc = ConsoleProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "EzGraphConsoleClass";
	wc.hIconSm = NULL;    
	if (RegisterClassEx(&wc) == 0){
        return 0;
	}

	// DialogEBhENX
	wc.cbSize = sizeof(WNDCLASSEX);
    // EBhEDC̑iIɂ邽OWNDCw
	wc.style = CS_OWNDC;
    wc.lpfnWndProc = DialogProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "EzGraphDialogClass";
	wc.hIconSm = NULL;    
	if (RegisterClassEx(&wc) == 0){
        return 0;
	}

	// ----- j[֌W̏
	mainMenu = CreateMenu();
	viewMenu = CreatePopupMenu();
	infoMenu = CreatePopupMenu();

	AppendMenu(mainMenu, MF_STRING, mid_quit, "I(&Q)");
	AppendMenu(mainMenu, MF_STRING | MF_POPUP, (UINT)viewMenu, "\(&V)");
	AppendMenu(viewMenu, MF_STRING, mid_console, "R\[(&C)");
	AppendMenu(viewMenu, MF_STRING, mid_magnify, "g(&M)");
	AppendMenu(mainMenu, MF_STRING | MF_POPUP, (UINT)infoMenu, "(&I)");
	AppendMenu(infoMenu, MF_STRING, mid_manual, "(&M)");
	AppendMenu(infoMenu, MF_STRING, mid_version, "o[W(&V)");
	AppendMenu(infoMenu, MF_STRING, mid_sysinfo, "VXe(&S)");
    SetMenu(win_hwnd, mainMenu);

	win_hdc = GetDC(win_hwnd);

	// ^Cgo[glđ傫𒲐
	// ItCrbg}bv͂̒ō̂ŁAuVȂǂ̐ݒ̒ł
	EzOpenWindow(EzDefaultWidth, EzDefaultHeight);

	// ShowWindowEzOpenWindowĂŃItCrbg}bv쐬ȂƉʂ
	ShowWindow(hwnd, SW_SHOW);
    UpdateWindow(hwnd);


    // _Ezname2rgbrgb.cŒ`ĂÓIɃTCY擾łȂ̂
	// œIɒׂ
	while (_EzName2RGB[name2rgb_num].name != NULL){
		name2rgb_num ++;
	}

	for (i = 0 ; i < VK2EZK_NUM ; i++){
		vk2ezk_table[vk2ezk[i].vk] = vk2ezk[i].ezk;
		vk2chr_table[vk2ezk[i].vk] = vk2ezk[i].chr;
		ezk2vk_table[vk2ezk[i].ezk] = vk2ezk[i].vk;
	}
	for (i = 0 ; i < EZK_ALIAS_NUM ; i++){
		ezk2vk_table[ezk_alias[i].ezk] = ezk_alias[i].vk;
	}

	GetModuleFileName(NULL, exePath, MAX_PATH);
	_backSlash2Slash(exePath);
	strcpy(exeDir, exePath);
	p = exeDir + strlen(exeDir);
	while (*p != '/') p--;
	*p = '\0';
	exeFile = p+1;

	_EzLoadInf();
	_EzLoadIni();
	applicationName = _EzReadIniString("Application", "Name", exeFile);
	SetWindowText(win_hwnd, applicationName);
	applicationVendor = _EzReadIniString("Application", "Vendor", NULL);
	applicationVersion = _EzReadIniString("Application", "Version", NULL);
	applicationManual = _EzReadIniString("Application", "Manual", NULL);
	if (applicationManual == NULL) _EzSetMenuInfoEnable(mainMenu, mid_manual, FALSE);

	left = _EzReadIniInt("Window", "Left", 100);
	top = _EzReadIniInt("Window", "Top", 100);
	MoveWindow(win_hwnd, left, top, client_width, client_height, TRUE);
	enableConsole = _EzReadIniInt("Console", "Show", 0);
	_EzSetMenuInfoCheck(mainMenu, mid_console, enableConsole);
	enableMagnify = _EzReadIniInt("Window", "Magnify", 0);
	_EzSetMenuInfoCheck(mainMenu, mid_magnify, enableMagnify);
	if (enableConsole){
		_EzCreateConsole();
	}

	_EzXPMInitialize();

	argv[0] = exePath;
	argc = 1;
//	_EzPrintf("argv:%s:\n", lpCmdLine);
	_EzCmdLine2Argv(lpCmdLine, argv, &argc);
    main(argc, argv);
	if (win_hwnd){
//		PostQuitMessage(0);
//		while (GetMessage(
	}
//	_EzSaveStat();
	return 0;
}
void _EzCmdLine2Argv(char *cmdline, char *argv[], int *argc){
	char *p, *str;
	int is_blank = 0, is_quoted = 0;

	str = malloc(strlen(cmdline)+1);
	strcpy(str, cmdline);
	p = str;

	*argc = 1;
	argv[*argc] = p;
	while (*p != '\0'){
		if (is_blank == 0 && is_quoted == 0 && *p == ' '){
			*p = '\0';
			is_blank = 1;
		}
		else if (is_blank && *p != ' '){
			if (*p == '"'){
				p ++;
				is_quoted = 1;
			}
			is_blank = 0;
			(*argc) ++;
			argv[*argc] = p;
		}
		else if (is_blank == 0 && is_quoted && *p == '"'){
			*p = '\0';
			is_blank = 1;
			is_quoted = 0;
		}
		else if (*p == '\\'){
			*p = '/';
		}
		p ++;
	}
	if (!is_blank){
		(*argc) ++;
	}
}

LRESULT CALLBACK WindowProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
//    static HBITMAP screenBuffer = NULL;
	PAINTSTRUCT ps;
    HDC hdc = NULL;
	switch (message) {
	case WM_LBUTTONDOWN:
		event_mouse.flag = -1;
		event_mouse.button = 1;
		event_mouse.x = LOWORD(lparam);
		event_mouse.y = HIWORD(lparam);
		return 0;
	case WM_MBUTTONDOWN:
		event_mouse.flag = -1;
		event_mouse.button = 2;
		event_mouse.x = LOWORD(lparam);
		event_mouse.y = HIWORD(lparam);
		return 0;
	case WM_RBUTTONDOWN:
		event_mouse.flag = -1;
		event_mouse.button = 3;
		event_mouse.x = LOWORD(lparam);
		event_mouse.y = HIWORD(lparam);
		return 0;
	case WM_LBUTTONUP:
		event_mouse_release.flag = -1;
		event_mouse_release.button = 1;
		event_mouse_release.x = LOWORD(lparam);
		event_mouse_release.y = HIWORD(lparam);
		return 0;
	case WM_MBUTTONUP:
		event_mouse_release.flag = -1;
		event_mouse_release.button = 2;
		event_mouse_release.x = LOWORD(lparam);
		event_mouse_release.y = HIWORD(lparam);
		return 0;
	case WM_RBUTTONUP:
		event_mouse_release.flag = -1;
		event_mouse_release.button = 3;
		event_mouse_release.x = LOWORD(lparam);
		event_mouse_release.y = HIWORD(lparam);
		return 0;
	case WM_KEYDOWN:
		_EzProcessKeyDown(wparam);
		return 0;
	case WM_KEYUP:
		_EzProcessKeyUp(wparam);
		return 0;
	case WM_CLOSE:
		if (confirmF){
			if (MessageBox(win_hwnd, "vOI܂H", "mF", MB_ICONQUESTION|MB_YESNO) == IDNO){
				return 0;
			}
		}
		if (enableConsole){
			_EzDestroyConsole();
		}
		_EzSaveStat();
		// DefWindowProcWM_CLOSEnƃN[Ys
		break;
	case WM_DESTROY:
        PostQuitMessage(0);
		_EzTerminate();
		win_hwnd = NULL;
        return 0;
	case WM_PAINT:
		// OWNDCwin_hdcDC펞ێĂ邪A
		// ̗̈L̂BeginPaint/EndPaintĂԕKv
		hdc = BeginPaint(win_hwnd, &ps);
		if (enableMagnify){
			StretchBlt(win_hdc, 0, 0, client_width*2, client_height*2, buf_hdc[onScreen], 0, 0, client_width, client_height, SRCCOPY);
		}
		else {
	        BitBlt(win_hdc, 0, 0, client_width, client_height, buf_hdc[onScreen], 0, 0, SRCCOPY);
		}
		EndPaint(win_hwnd, &ps);
		return 0;
                // WM_PAINTŖɍĕ`悷ȂÃnh͕sv
                //	case WM_ACTIVATE:
                // ItC`̏ꍇ́A
                // EBhEANeBuɂȂƂ
                // obt@]`悷
                // !!! mANeBuɂȂƂ̃nhĂ΂̂ŁA
                // wparam̒lmFăANeBûݕ`悵قǂ
                //                if (forceOffline){
                //                    EzShowBuffer();
                //                }
                //                return 0;
	case WM_COMMAND:
		// j[WM_COMMAND̏
		if (lparam == 0){
			switch (LOWORD(wparam)) {
         	case mid_quit:
                SendMessage(win_hwnd, WM_CLOSE, 0, 0);
				break;
         	case mid_console:
				if (enableConsole){
					_EzDestroyConsole();
				}
				else {
					_EzCreateConsole();
				}
				_EzWriteIniInt("Console", "Show", enableConsole);
				break;
         	case mid_magnify:
				_EzToggleMagnify();
				_EzWriteIniInt("Window", "Magnify", enableMagnify);
				break;
         	case mid_manual:
				_EzShowManual();
				break;
         	case mid_version:
				_EzShowVersion();
				break;
         	case mid_sysinfo:
				_EzShowSysInfo();
				break;
			default:
				break;
			}
		}
		return 0;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}
void _EzProcessKeyDown(WPARAM wparam){
	int key, vk, is_repeat = 0;

	if (wparam == prev_wparam){
		// shift, control, alt̃s[g͖
		if (wparam == VK_SHIFT || wparam == VK_CONTROL || wparam == VK_MENU){
			return;
		}
		else {
			is_repeat = 1;
		}
	}
	prev_wparam = wparam;

	wparam = _EzCheckModKey(wparam);
	vk = wparam & 0xff;
    vk_map[(vk >> 3)] |= (1 << (vk & 0x07));

	// CTRL+A-ẐƂ͐R[h1`26𔭐
	if (is_control_down && vk >= 0x41 && vk <= 0x5a){
		key = vk - 0x40;
	}
	else if (is_shift_down){
		key = vk2chr_table[vk].shifted;
	}
	else {
		key = vk2chr_table[vk].nonshifted;
	}
	// `L[̏ꍇ͖
	if (key == 0) return;

	// EzGraphɍ킹AL[s[gKEY_UP
	if (is_repeat){
		_EzEnqueueKeyEvent(key, 0);
	}
	_EzEnqueueKeyEvent(key, 1);
}
void _EzProcessKeyUp(WPARAM wparam){
	int key, vk;

	// xUPꂽēxL[DOWNĂL(i.e.A)
	prev_wparam = 0;

	wparam = _EzCheckModKey(wparam);
	vk = wparam & 0xff;
    vk_map[(vk >> 3)] ^= (1 << (vk & 0x07));

	// CTRL+A-ẐƂ͐R[h1`26𔭐
	if (is_control_down && vk >= 0x41 && vk <= 0x5a){
		key = vk - 0x40;
	}
	else if (is_shift_down){
		key = vk2chr_table[vk].shifted;
	}
	else {
		key = vk2chr_table[vk].nonshifted;
	}
	// `L[̏ꍇ͖
	if (key == 0) return;

	_EzEnqueueKeyEvent(key, 0);
}
WPARAM _EzCheckModKey(WPARAM wparam){
	int diff, new_state = 0;
	switch (wparam){
    case VK_SHIFT:
		new_state = ((GetKeyState(VK_LSHIFT) & 0x80) ? 1 : 0)
			      + ((GetKeyState(VK_RSHIFT) & 0x80) ? 2 : 0);
		diff = new_state ^ is_shift_down;
		if (diff == 1){
			wparam = VK_LSHIFT;
		}
		else if (diff == 2){
			wparam = VK_RSHIFT;
		}
		else {
			return 0;
		}
		is_shift_down = new_state;
		break;
    case VK_CONTROL:
		new_state = ((GetKeyState(VK_LCONTROL) & 0x80) ? 1 : 0)
			      + ((GetKeyState(VK_RCONTROL) & 0x80) ? 2 : 0);
		diff = new_state ^ is_control_down;
		if (diff == 1){
			wparam = VK_LCONTROL;
		}
		else if (diff == 2){
			wparam = VK_RCONTROL;
		}
		else {
			return 0;
		}
		is_control_down = new_state;
		break;
    case VK_MENU:
		new_state = ((GetKeyState(VK_LMENU) & 0x80) ? 1 : 0)
			      + ((GetKeyState(VK_RMENU) & 0x80) ? 2 : 0);
		diff = new_state ^ is_alt_down;
		if (diff == 1){
			wparam = VK_LMENU;
		}
		else if (diff == 2){
			wparam = VK_RMENU;
		}
		else {
			return 0;
		}
		is_alt_down = new_state;
		break;
	default:
		break;
	}
	return wparam;
}

int _EzEnqueueKeyEvent(int key, int is_down){
	event_key_queue[event_key_queue_tail].key = key;
	event_key_queue[event_key_queue_tail].is_down = is_down;
	event_key_queue_tail = (event_key_queue_tail + 1) % EVENT_QUEUE_SIZE;
	return 0;
}


void _EzTerminate(void){
	int i;

    _EzXPMTerminate();

	for (i = 0 ; i < 2 ; i++){
  		DeleteObject(buf_bmp[i]);
		DeleteDC(buf_hdc[i]);
	}
	ReleaseDC(win_hwnd, win_hdc);  // win_hdcGetDCŎ擾̂ReleaseDC
}

void _EzSetMenuInfoCheck(HMENU hmenu, UINT item, int flag){
	MENUITEMINFO menuItemInfo;
	memset(&menuItemInfo, 0, sizeof(menuItemInfo));
	menuItemInfo.cbSize = sizeof(menuItemInfo);
	menuItemInfo.fMask = MIIM_STATE;
	menuItemInfo.fState = flag ? MFS_CHECKED : MFS_UNCHECKED;
	SetMenuItemInfo(hmenu, item, FALSE, &menuItemInfo);
	DrawMenuBar(win_hwnd);
}
void _EzSetMenuInfoEnable(HMENU hmenu, UINT item, int flag){
	MENUITEMINFO menuItemInfo;
	memset(&menuItemInfo, 0, sizeof(menuItemInfo));
	menuItemInfo.cbSize = sizeof(menuItemInfo);
	menuItemInfo.fMask = MIIM_STATE;
	menuItemInfo.fState = flag ? MFS_ENABLED : MFS_DISABLED;
	SetMenuItemInfo(hmenu, item, FALSE, &menuItemInfo);
	DrawMenuBar(win_hwnd);
}

void _EzToggleMagnify(void){
	enableMagnify = !enableMagnify;
	_EzSetMenuInfoCheck(mainMenu, mid_magnify, enableMagnify);
	_EzSetWindowSize(client_width, client_height);
	InvalidateRect(win_hwnd, NULL, FALSE);
}

void _EzCreateConsole(void){
	RECT cRect;
//	MENUITEMINFO menuItemInfo;
	HINSTANCE hInstance;
	HDC hdc;
	int left, top;

    hInstance = (HINSTANCE)GetWindowLong(win_hwnd, GWL_HINSTANCE);
	left = _EzReadIniInt("Console", "Left", 0);
	top = _EzReadIniInt("Console", "Top", 0);

	SetRect(&cRect, left, top, left+CONSOLE_WIDTH, top+CONSOLE_HEIGHT);
	AdjustWindowRectEx(&cRect, CONSOLE_DWSTYLE, FALSE, CONSOLE_DWEXSTYLE);

	consoleHwnd = CreateWindowEx(CONSOLE_DWEXSTYLE, "EzGraphConsoleClass", "EzGraph Console",
		                         CONSOLE_DWSTYLE,
								 left, top,
								 cRect.right-cRect.left, cRect.bottom-cRect.top,
								 win_hwnd, NULL, hInstance, NULL);
	if (consoleHwnd != NULL){
		enableConsole = 1;
		_EzSetMenuInfoCheck(mainMenu, mid_console, enableConsole);
//		memset(&menuItemInfo, 0, sizeof(menuItemInfo));
//		menuItemInfo.cbSize = sizeof(menuItemInfo);
//		menuItemInfo.fMask = MIIM_STATE;
//		menuItemInfo.fState = MFS_CHECKED;
//		SetMenuItemInfo(mainMenu, mid_console, FALSE, &menuItemInfo);
//		DrawMenuBar(win_hwnd);
		enableConsole = 1;
	}

	hdc = GetDC(consoleHwnd);
//	hpen_old = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(255,255,255)));
//  DeleteObject(hpen_old);
	SetTextColor(hdc, RGB(255, 255, 255));
	SetBkMode(hdc, TRANSPARENT);

    memset(&consoleFont, 0, sizeof(consoleFont));
	// [U\[XShiftJisłƑz肵Ă̂ŁA
        // ShiftJisɐݒ肵Ȃƕ
	consoleFont.lfCharSet = SHIFTJIS_CHARSET;
	consoleFont.lfPitchAndFamily = FIXED_PITCH;
	consoleFont.lfHeight = CONSOLE_FONTSIZE;


}

void _EzDestroyConsole(void){
//	MENUITEMINFO menuItemInfo;
	RECT wRect;

	GetWindowRect(consoleHwnd, &wRect);
	_EzWriteIniInt("Console", "Left", wRect.left);
	_EzWriteIniInt("Console", "Top", wRect.top);


	SendMessage(consoleHwnd, WM_CLOSE, 0, 0);
	consoleHwnd = NULL;
//	memset(&menuItemInfo, 0, sizeof(menuItemInfo));
//	menuItemInfo.cbSize = sizeof(menuItemInfo);
//	menuItemInfo.fMask = MIIM_STATE;
//	menuItemInfo.fState = MFS_UNCHECKED;
//	SetMenuItemInfo(mainMenu, mid_console, FALSE, &menuItemInfo);
//	DrawMenuBar(win_hwnd);
	enableConsole = 0;
	_EzSetMenuInfoCheck(mainMenu, mid_console, enableConsole);
}


LRESULT CALLBACK ConsoleProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
	PAINTSTRUCT ps;
    HDC hdc = NULL;
    int i, ix;
//	char buf[16];
	HFONT hFont;

	switch (message) {
	case WM_PAINT:
		hdc = BeginPaint(consoleHwnd, &ps);
		hFont = CreateFontIndirect(&consoleFont);
		SelectObject(hdc, hFont);
		PatBlt(hdc, 0, 0, CONSOLE_WIDTH, CONSOLE_HEIGHT, BLACKNESS);
	 	ix = (console_tail+1) % CONSOLE_LINES;
		for (i = 0 ; i < CONSOLE_LINES ; i++){
//			sprintf(buf, "%2d", ix);
//			TextOut(hdc, 0, i*16, buf, strlen(buf));
			TextOut(hdc, CONSOLE_MARGIN, i*CONSOLE_FONTSIZE+CONSOLE_MARGIN,
				    console_text[ix], (int)strlen(console_text[ix]));
			ix = (ix + 1) % CONSOLE_LINES;
		}
		DeleteObject(hFont);
		EndPaint(consoleHwnd, &ps);
		return 0;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}

void _EzSetWindowSize(int width, int height){
    RECT wRect, cRect;

	GetWindowRect(win_hwnd, &wRect);
	GetClientRect(win_hwnd, &cRect);
	if (enableMagnify){
		cRect.right = width*2;
		cRect.bottom = height*2 + GetSystemMetrics(SM_CYSIZE);
	}
	else {
		cRect.right = width;
		cRect.bottom = height + GetSystemMetrics(SM_CYSIZE);
	}
	// o[W̓j[Ȃ̂ŁA3false
	AdjustWindowRect(&cRect, WINDOW_STYLE, FALSE);
	MoveWindow(win_hwnd, wRect.left, wRect.top, cRect.right-cRect.left, cRect.bottom-cRect.top, TRUE);
}

int EzOpenWindow(int width, int height){
	HBRUSH hBrush;
	int i;

	client_width = width;
	client_height = height;
	_EzSetWindowSize(width, height);

	// VEBhETCYŃItCrbg}bv蒼
	for (i = 0 ; i < 2 ; i++){
		if (buf_bmp[i] != NULL){
			DeleteObject(buf_bmp[i]);
			DeleteDC(buf_hdc[i]);
		}
		buf_hdc[i] = CreateCompatibleDC(win_hdc);
	   	buf_bmp[i] = CreateCompatibleBitmap(win_hdc, client_width, client_height);
		SelectObject(buf_hdc[i], buf_bmp[i]);
	}
	offScreen = 0;
	onScreen = 1;
//    draw_hdc = buf_hdc[offScreenBuf];
	// ----- eLXg֌W̏
	// eLXg̔wi͓߂
	SetBkMode(buf_hdc[0], TRANSPARENT);
	SetBkMode(buf_hdc[1], TRANSPARENT);

	// ftHg̐}``͓hԂȂ(Draw)Ȃ̂ŃuV𓧖ɂĂ
	// (Win32ł̓ftHgWHITE_BRUSHo^Ă)
	// hԂn(Fill)`͂̓sxA݂̕`F̃uVƌĕ`悷
	hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
	SelectObject(win_hdc, hBrush);
	SelectObject(buf_hdc[0], hBrush);
	SelectObject(buf_hdc[1], hBrush);
//	hbrush_old = SelectObject(buf_hdc, hbrush);
//    DeleteObject(hbrush_old);

	// ----- eLXg֌W̏
	// eLXg̔wi͓߂
	SetBkMode(win_hdc, TRANSPARENT);
	SetBkMode(buf_hdc[0], TRANSPARENT);
	SetBkMode(buf_hdc[1], TRANSPARENT);
    memset(&logFont, 0, sizeof(logFont));
	// [U\[XShiftJisłƑz肵Ă̂ŁA
        // ShiftJisɐݒ肵Ȃƕ
	logFont.lfCharSet = SHIFTJIS_CHARSET;
	// Ƃ肠IWił̃ftHgɍ킹Œ蕝tHgɂĂ
	logFont.lfPitchAndFamily = FIXED_PITCH;
	EzSetFontSize(EzDefaultFontSize);

        // EzGraph͕`F̏l
	EzSetColorByRGB(255,255,255);

    // ItCrbg}bvɕ`悵ȂꍇAOnPaintŐVEBhË悪NAȂ߁A
	// IEzClearǂł
	EzClear();
	return 0;
}

int EzDrawPoint(int x, int y){
	if (!enableMagnify){
		_EzDrawPoint(win_hdc, x, y);
	}
	_EzDrawPoint(buf_hdc[onScreen], x, y);
	return 0;
}
int EzDrawPointB(int x, int y){
	_EzDrawPoint(buf_hdc[offScreen], x, y);
	return 0;
}
int _EzDrawPoint(HDC hdc, int x, int y){
	SetPixel(hdc, x, y, pen_color);
	return 0;
}

int EzDrawLine(int x1, int y1, int x2, int y2){
	if (!enableMagnify){
		_EzDrawLine(win_hdc, x1, y1, x2, y2);
	}
	_EzDrawLine(buf_hdc[onScreen], x1, y1, x2, y2);
	return 0;
}
int EzDrawLineB(int x1, int y1, int x2, int y2){
	_EzDrawLine(buf_hdc[offScreen], x1, y1, x2, y2);
	return 0;
}
int _EzDrawLine(HDC hdc, int x1, int y1, int x2, int y2){
	MoveToEx(hdc, x1, y1, NULL);
	LineTo(hdc, x2, y2);
	// LineTo͏I_`悵Ȃ̂ŕʓrI_`
	SetPixel(hdc, x2, y2, pen_color);
	return 0;
}

int EzDrawBox(int x1, int y1, int x2, int y2){
	if (!enableMagnify){
		_EzDrawBox(win_hdc, x1, y1, x2, y2);
	}
	_EzDrawBox(buf_hdc[onScreen], x1, y1, x2, y2);
	return 0;
}
int EzDrawBoxB(int x1, int y1, int x2, int y2){
	_EzDrawBox(buf_hdc[offScreen], x1, y1, x2, y2);
	return 0;
}
int _EzDrawBox(HDC hdc, int x1, int y1, int x2, int y2){
	// Rectangle͉ӁEEӂ܂܂Ȃ
	Rectangle(hdc, x1, y1, x2+1, y2+1);
	return 0;
}


int EzFillBox(int x1, int y1, int x2, int y2){
	if (!enableMagnify){
		_EzFillBox(win_hdc, x1, y1, x2, y2);
	}
    _EzFillBox(buf_hdc[onScreen], x1, y1, x2, y2);
	return 0;
}
int EzFillBoxB(int x1, int y1, int x2, int y2){
    _EzFillBox(buf_hdc[offScreen], x1, y1, x2, y2);
	return 0;
}
int _EzFillBox(HDC hdc, int x1, int y1, int x2, int y2){
	InitFill();
	BeginFill();
	_EzDrawBox(hdc, x1, y1, x2, y2);
	EndFill();
	return 0;
}

int EzDrawCircle(int x, int y, unsigned int r){
	if (!enableMagnify){
		_EzDrawCircle(win_hdc, x, y, r);
	}
	_EzDrawCircle(buf_hdc[onScreen], x, y, r);
	return 0;
}
int EzDrawCircleB(int x, int y, unsigned int r){
	_EzDrawCircle(buf_hdc[offScreen], x, y, r);
	return 0;
}
int _EzDrawCircle(HDC hdc, int x, int y, unsigned int r){
	int left, top, right, bottom;
	left = x - r;
	top = y - r;
	right = x + r;
	bottom = y + r;
	// Ellipse͋`(left, top)-(right, bottom)̓()~`
	// !!!㉺E̕ӂ܂ނǂv`FbN
    Ellipse(hdc, left, top, right, bottom);
	return 0;
}

int EzFillCircle(int x, int y, unsigned int r){
	if (!enableMagnify){
		_EzFillCircle(win_hdc, x, y, r);
	}
	_EzFillCircle(buf_hdc[onScreen], x, y, r);
	return 0;
}
int EzFillCircleB(int x, int y, unsigned int r){
	_EzFillCircle(buf_hdc[offScreen], x, y, r);
	return 0;
}
int _EzFillCircle(HDC hdc, int x, int y, unsigned int r){
	InitFill();
	BeginFill();
	_EzDrawCircle(hdc, x, y, r);
	EndFill();
	return 0;
}

int EzDrawArc(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
	if (!enableMagnify){
	    _EzDrawArc(win_hdc, x, y, rx, ry, t1, t2);
	}
	_EzDrawArc(buf_hdc[onScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int EzDrawArcB(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
    _EzDrawArc(buf_hdc[offScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int _EzDrawArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
	int left, top, right, bottom;
	int sx, sy, ex, ey;
	_conv_arc_param(x, y, rx, ry, t1, t2, &left, &top, &right, &bottom, &sx, &sy, &ex, &ey);
    Arc(hdc, left, top, right, bottom, sx, sy, ex, ey);
	return 0;
}

int EzFillArc(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
	if (!enableMagnify){
	    _EzFillArc(win_hdc, x, y, rx, ry, t1, t2);
	}
	_EzFillArc(buf_hdc[onScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int EzFillArcB(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
    _EzFillArc(buf_hdc[offScreen], x, y, rx, ry, t1, t2);
	return 0;
}
int _EzFillArc(HDC hdc, int x, int y, unsigned int rx, unsigned int ry, int t1, int t2){
	int left, top, right, bottom;
	int sx, sy, ex, ey;
	InitFill();
	_conv_arc_param(x, y, rx, ry, t1, t2, &left, &top, &right, &bottom, &sx, &sy, &ex, &ey);
	BeginFill();
    Pie(hdc, left, top, right, bottom, sx, sy, ex, ey);
	EndFill();
	return 0;
}

void _conv_arc_param(int x, int y, unsigned int rx, unsigned int ry, int t1, int t2,
					 int *left, int *top, int *right, int *bottom, int *sx, int *sy, int *ex, int *ey)
{
	// Arc/Pie͋`(left, top)-(right, bottom)̓()~̌ʂ`
	*left = x - rx;
	*top = y - ry;
	*right = x + rx;
	*bottom = y + ry;
	// t1, t2͊JnpEIp(P:xAE0ƂĔv)
	// Pie̊JnEIʒu͒S_(sx, sy), (ex, ey)֐L΂Ɖ~̌_Ŏw肷
	*sx = (int)(cos(t1*PI/180)*1000) + x;
	*sy = -(int)(sin(t1*PI/180)*1000) + y;
	*ex = (int)(cos(t2*PI/180)*1000) + x;
	*ey = -(int)(sin(t2*PI/180)*1000) + y;
}

int EzFillPolygon(int num, int *poly){
	if (!enableMagnify){
		_EzFillPolygon(win_hdc, num, poly);
	}
	_EzFillPolygon(buf_hdc[onScreen], num, poly);
	return 0;
}
int EzFillPolygonB(int num, int *poly){
	_EzFillPolygon(buf_hdc[offScreen], num, poly);
	return 0;
}
int _EzFillPolygon(HDC hdc, int num, int *poly){
	InitFill();
	BeginFill();
	if (sizeof(int)*2 == sizeof(POINT)){
		Polygon(hdc, (POINT*)poly, num);
	}
	else {
		// !!! intlong̃TCYvȂꍇ́ApolyPOINT̔zɃRs[ĂPolygon()
	}
	EndFill();
	return 0;
}

int EzDrawString(int x, int y, char *s){
	if (!enableMagnify){
		_EzDrawString(win_hdc, x, y, s);
	}
	_EzDrawString(buf_hdc[onScreen], x, y, s);
	return 0;
}
int EzDrawStringB(int x, int y, char *s){
	_EzDrawString(buf_hdc[offScreen], x, y, s);
	return 0;
}
int _EzDrawString(HDC hdc, int x, int y, char *s){
	HFONT hFont;
    // tHgTCY͂̓sxHFONT쐬Đݒ
    hFont = CreateFontIndirect(&logFont);
	SelectObject(hdc, hFont);
	TextOut(hdc, x, y-fontSize, s, (int)strlen(s));
	DeleteObject(hFont);
	return 0;
}

int EzClear(void){
	if (!enableMagnify){
		_EzClear(win_hdc);
	}
	_EzClear(buf_hdc[onScreen]);
	return 0;
}

// EzClearB݂͑ȂA
// EzGraphŃItCrbg}bvNAł悤ɁAwin, bufɑΉĂ
int _EzClear(HDC hdc){
    // PatBltBLACKNESSnƁAuVyݒ肵ȂĂœhԂ
	PatBlt(hdc, 0, 0, client_width, client_height, BLACKNESS);
	return 0;
}

int EzShowBuffer(void){
	// _uobt@̃IXN[^ItXN[ĐVItXN[NA
	onScreen = offScreen;
	offScreen = 1-onScreen;
//	draw_hdc = buf_hdc[offScreen];
	_EzClear(buf_hdc[offScreen]);
	InvalidateRect(win_hwnd, NULL, FALSE);    
//	UpdateWindow(win_hwnd);
//	showBufferF = -1;
	return 0;
}

// !!! Ƃ肠XN[AItCrbg}bvƂFݒ肵Ă
int EzSetColorByRGB(unsigned short r, unsigned short g, unsigned short b){
	HPEN hpen_old;
	// pen_colorSetPixelłĝŁAO[oɒlێKv
	pen_color = RGB(r, g, b);
	hpen_old = SelectObject(win_hdc, CreatePen(PS_SOLID, 1, pen_color)); 
    DeleteObject(hpen_old);
	// !!! IXN[obt@win_hdcւ̓]Ȃ̂ŁAFݒ͕svȂ
	hpen_old = SelectObject(buf_hdc[onScreen], CreatePen(PS_SOLID, 1, pen_color)); 
    DeleteObject(hpen_old);
	hpen_old = SelectObject(buf_hdc[offScreen], CreatePen(PS_SOLID, 1, pen_color)); 
    DeleteObject(hpen_old);
	// Win32ł̓eLXg̐F͕ʓrw肪Kv
	SetTextColor(win_hdc, pen_color);
	SetTextColor(buf_hdc[onScreen], pen_color);
	SetTextColor(buf_hdc[offScreen], pen_color);
	return 0;
}

int EzSetColorByName(char *s){
	char name[128];
	int i;

	// name2rgb͏\L
	// [U啶ŖOw肵ꍇɔA
        // Ăr
	_downcase(s, name);
	// ݂͐`T
	// name2rgb͎Ă̂ŁAEzGraphname2rgb
        // Ƀ\[gĂ񕪒T
	for (i = 0 ; i < name2rgb_num ; i++){
		if (strcmp(name, _EzName2RGB[i].name) == 0){
			EzSetColorByRGB(_EzName2RGB[i].r, _EzName2RGB[i].g, _EzName2RGB[i].b);
			return 0;
		}
	}
	return -1;
}

// !!! o[W͂ȂɂȂ
int EzSetFont(char *s){
	return 0;
}

int EzSetFontSize(int i){
    fontSize = i;
	logFont.lfHeight = fontSize;
    return 0;
}

int EzSetMouseHandler(EzMouseHandler func){
	mouseh_func = func;
	return 0;
}

int EzSetMouseReleaseHandler(EzMouseHandler func){
	mouse_releaseh_func = func;
	return 0;
}

int EzSetKeyHandler(EzKeyHandler func){
	keyh_func = func;
	return 0;
}

int EzSetKeyReleaseHandler(EzKeyHandler func){
	key_releaseh_func = func;
	return 0;
}

// !!! oOFVXeN49.7GetTickCount̕Ԃl0ɖ߂̂
// ̋E܂ŃvO𑖂点ƃnOH
int EzSetTimerHandler(EzTimerHandler func, unsigned long ms){
	DWORD currentTime;
	currentTime= GetTickCount();
	timerh_nexttime = currentTime += ms;
	timerh_func = func;
	timerh_ms = ms;
//        if (func == NULL && forceOffline){
////            EzShowBuffer();
//        }
	return 0;
}

void EzEventLoop(void){
	MSG msg;
//    EzTimerHandler tfunc;
	DWORD currentTime;

	while(1){
		if (mouseh_func != NULL && event_mouse.flag != 0){
			event_mouse.flag = 0;
			mouseh_func(event_mouse.x, event_mouse.y, event_mouse.button);
			if (enableMagnify){
				InvalidateRect(win_hwnd, NULL, FALSE);
			}
		}
		if (mouse_releaseh_func != NULL && event_mouse_release.flag != 0){
			event_mouse_release.flag = 0;
			mouse_releaseh_func(event_mouse_release.x, event_mouse_release.y,
								event_mouse_release.button);
			if (enableMagnify){
				InvalidateRect(win_hwnd, NULL, FALSE);
			}
		}
		// 1msɃL[down/upCɔA邢͕̃L[down\
		// ̂ŁAL[Cxg̓L[ɓo^ĂɃnhĂяoĂ
		// !!! }EX{^lɏ悢H
		if (event_key_queue_head != event_key_queue_tail){
			if (event_key_queue[event_key_queue_head].is_down){
				if (keyh_func != NULL){
					keyh_func(event_key_queue[event_key_queue_head].key);
				}
			}
			else {
				if (key_releaseh_func != NULL){
					key_releaseh_func(event_key_queue[event_key_queue_head].key);
				}
			}
			event_key_queue_head = (event_key_queue_head + 1) % EVENT_QUEUE_SIZE;
			if (enableMagnify){
				InvalidateRect(win_hwnd, NULL, FALSE);
			}
		}
		if (timerh_func != NULL && GetTickCount() >= timerh_nexttime){
			// ̃^C}荞ݎԂtimer_msɎ̊荞݂̂
			// timerh_funcĂяoOnexttimevZĂ
			// timerh_func̏vԂtimerh_ms蒷ΏN
			// timerh_funcďonexttimevZΏ͋NȂ
			// 荞݊Ԋutimerh_func̏vԂZ(ŜɒxȂ)
			currentTime= GetTickCount();
			timerh_nexttime = currentTime += timerh_ms;
			timerh_func();
			// g\[hł̓EBhEɒڕ`悹A
			// ^C}荞ݖɃItCrbg}bv]
			if (enableMagnify){
				InvalidateRect(win_hwnd, NULL, FALSE);
			}

//                        if (forceOffline){
//                            InvalidateRect(win_hwnd, NULL, FALSE);
//                            // EzShowBuffer();
//                        }
		}
//		if (exitF){
//			return;
//		}
		// GetMessage̓ubLOȂ̂PeekMessageg
		while (PeekMessage(&msg,NULL,0,0, PM_REMOVE)){
			// PeekMessage͕ԂlWM_QUITǂfłȂ̂
			// IɃ`FbN
			if (msg.message == WM_QUIT){
				return;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		Sleep(1);
	}
}


void EzExitEventLoop(void){
	confirmF = 0;
	PostMessage(win_hwnd, WM_CLOSE, 0, 0);
//	exitF = -1;
}


int EzQueryKeymap(char keys[32]){
	memcpy(keys, vk_map, sizeof(char)*32);
	// !!! Ƃ肠A0ԂƂɂ
	// !!! IWiłɏ]ȂAEBhẼtH[JXOĂAkeysׂ0ɂ
	return 0;
}


int EzIsKeyPress(char keys[32], int code){
	unsigned char vk = ezk2vk_table[code];
//    code = code & 0xff;
	if ((keys[(vk >> 3)] & (1 << (vk & 0x07))) != 0){
		return -1;
	}
	else {
		return 0;
	}
}

xpm_bmp_t *_EzCreateBMP(int width, int height){
	BITMAPINFO bmpInfo;
#ifdef _EZ_COMBINED_BMP
	int bmpHeight;
#endif
	_EzPrintf("createBMP No.%d %d x %d\n", xpm_bmp_num, width, height);
	// !!! ێpz̑傫𒴂AƂ肠sĂ
	if (xpm_bmp_num > xpm_bmp_max){
		_EzError("xpmf[^%d𒴂܂B", xpm_bmp_max);
		return NULL;
	}
	ZeroMemory(&bmpInfo, sizeof(bmpInfo));
	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biBitCount = 32;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biWidth = width;
#ifdef _EZ_COMBINED_BMP
	if (enable_combined_bmp){
		bmpHeight = combined_bmp_size*1024/4/width;
		if (bmpHeight >= height * COMBINED_BMP_THRESHOLD){
			bmpInfo.bmiHeader.biHeight = -bmpHeight;
		}
		else {
			bmpInfo.bmiHeader.biHeight = -height;
		}
		xpm_bmps[xpm_bmp_num].width = width;
		xpm_bmps[xpm_bmp_num].currentHeight = 0;
	}
	else {
		bmpInfo.bmiHeader.biHeight = -height;
	}
#else
	bmpInfo.bmiHeader.biHeight = -height;
#endif	
	xpm_bmps[xpm_bmp_num].bmp = CreateDIBSection(NULL, &bmpInfo, DIB_RGB_COLORS, NULL, NULL, 0);
//	xpm_bmps[xpm_bmp_num].bmp = CreateCompatibleBitmap(win_hdc, width, height);
	assert(xpm_bmps[xpm_bmp_num].bmp != NULL);
	xpm_bmps[xpm_bmp_num].mask = CreateDIBSection(NULL, &bmpInfo, DIB_RGB_COLORS, NULL, NULL, 0);
//	xpm_bmps[xpm_bmp_num].mask = CreateCompatibleBitmap(win_hdc, width, height);
	assert(xpm_bmps[xpm_bmp_num].mask != NULL);
	xpm_bmp_num ++;

	return &xpm_bmps[xpm_bmp_num-1];
}





EzImage EzReadXPM(char **xpm){
	EzImage img;
	int width, height, color_num, len, i, x, y; 
	unsigned int color;
	COLORREF color_table[0x4000];
	unsigned char c1, c2;
	char color_name[256];
	HDC image_hdc, mask_hdc;
//	BITMAPINFO bmpinfo;
	xpm_bmp_t *xpmBmp = NULL;
	int yoffset = 0;

	if (sscanf(xpm[0], "%d %d %d %d", &width, &height, &color_num, &len) != 4){
		_EzError("xpmf[^1sڂɌ肪܂B");
		img.height = 0;
		return img;
	}
	img.width = width;
	img.height = height;

#ifdef _EZ_COMBINED_BMP
	if (enable_combined_bmp){
		for (i = xpm_bmp_num-1 ; i >= 0 ; i--){
			if (xpm_bmps[i].width == width){
				// ŏɌ(ŐV)vGgg
				// ̕󂫂Ȃ΁AɃ[v𔲂ĐVKɍ
				// ̃GgĂAŐV̂̈ȊO͋󂫂Ȃ͂B
				// @ۂ́Aō̈قȂ摜݂ꍇAO̔荂
				//   Ⴂ摜ƁAÕGgɊi[ł\B
				//   Aʏ͕ÊP[X낤A
				//   莞ԒZkD悵čŐV̂̂̂݃`FbNB
				if (xpm_bmps[i].currentHeight + height < combined_bmp_size*1024/4/width){
					xpmBmp = &xpm_bmps[i];
				}
				break;
			}
		}
		// widthBMPȂΐVK쐬
		if (xpmBmp == NULL){
			xpmBmp = _EzCreateBMP(width, height);
		}
		img.heightOffset = xpmBmp->currentHeight;
		xpmBmp->currentHeight += height;
		yoffset = img.heightOffset;
	}
	else {
		xpmBmp = _EzCreateBMP(width, height);
	}
#else
	xpmBmp = _EzCreateBMP(width, height);

#endif
	// rbg}bvmۂɎsAimg̕EɂĖ߂
	if (xpmBmp == NULL){
		img.width = 0;
		img.height = 0;
		img.image = NULL;
		img.mask = NULL;
		return img;
	}
	img.image = xpmBmp->bmp;
	img.mask = xpmBmp->mask;
	for (i = 0 ; i < color_num ; i++){
		c1 = xpm[1+i][0];
		c2 = xpm[1+i][1];
		if (sscanf(&xpm[1+i][2], " c %s", color_name) != 1){
			_EzError("xpmf[^̐F(%ds)Ɍ肪܂B", i+1);
			img.height = 0;
			return img;
		}
		if (sscanf(color_name, "#%x", &color) == 1){
			color_table[XpmChar2ColNo(c1, c2)] = color;
		}
		else {
			if (strcmp(color_name, "none") == 0 || strcmp(color_name, "None") == 0){
				color_table[XpmChar2ColNo(c1, c2)] = 0xffffffff;
			}
			else {
				// FRGBɕϊăe[uɊi[
  				_EzError("o[Włxpmf[^̐FɐF(%ds)͎g܂B", i+1);
			}
		}
	}
	image_hdc = CreateCompatibleDC(win_hdc);
	assert(image_hdc != NULL);
	mask_hdc = CreateCompatibleDC(win_hdc);
	assert(mask_hdc != NULL);
	SelectObject(image_hdc, img.image);
	SelectObject(mask_hdc, img.mask);
	for (y = 0 ; y < img.height ; y ++){
		for (x = 0 ; x < img.width ; x ++){
			if (len == 1){
				c1 = xpm[y + color_num+1][x];
				c2 = 32;
			}
			else if (len == 2){
				c1 = xpm[y + color_num+1][x*2];
				c2 = xpm[y + color_num+1][x*2+1];
			}
			color = color_table[XpmChar2ColNo(c1, c2)];
			if (color == 0xffffffff){
				SetPixel(image_hdc, x, y+yoffset, 0x000000);	
				SetPixel(mask_hdc, x, y+yoffset, 0xffffff);	
			}
/*
			else if (color == 0){
				SetPixel(image_hdc, x, y, 0xff0000);	
			}
*/
			else {
				SetPixel(image_hdc, x, y+yoffset, RGB2COLORREF(color));	
				SetPixel(mask_hdc, x, y+yoffset, 0x00000);	
			}
		}
	}

	DeleteDC(image_hdc);
	DeleteDC(mask_hdc);
	return img;
}
#ifdef DUMMY
	// !!! ێpz̑傫𒴂AƂ肠sĂ
	if (xpm_bmp_num > XPM_BMP_MAX){
		_EzError("xpmf[^𒴂܂B");
		img.width = 0;
		img.height = 0;
		return img;
	}
	ZeroMemory(&bmpinfo, sizeof(bmpinfo));
	bmpinfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpinfo.bmiHeader.biBitCount = 32;
	bmpinfo.bmiHeader.biPlanes = 1;
	bmpinfo.bmiHeader.biWidth = width;
	bmpinfo.bmiHeader.biHeight = -height;

	img.image = CreateDIBSection(NULL, &bmpinfo, DIB_RGB_COLORS, NULL, NULL, 0);
//	img.image = CreateCompatibleBitmap(win_hdc, width, height);
	assert(img.image != NULL);
	xpm_bmp[xpm_bmp_num++] = img.image;
	img.mask = CreateDIBSection(NULL, &bmpinfo, DIB_RGB_COLORS, NULL, NULL, 0);
//	img.mask = CreateCompatibleBitmap(win_hdc, width, height);
	assert(img.mask != NULL);
	xpm_bmp[xpm_bmp_num++] = img.mask;

	for (i = 0 ; i < color_num ; i++){
		c1 = xpm[1+i][0];
		c2 = xpm[1+i][1];
		if (sscanf(&xpm[1+i][2], " c %s", color_name) != 1){
			_EzError("xpmf[^̐F(%ds)Ɍ肪܂B", i+1);
			img.height = 0;
			return img;
		}
		if (sscanf(color_name, "#%x", &color) == 1){
			color_table[XpmChar2ColNo(c1, c2)] = color;
		}
		else {
			if (strcmp(color_name, "none") == 0 || strcmp(color_name, "None") == 0){
				color_table[XpmChar2ColNo(c1, c2)] = 0xffffffff;
			}
			else {
				// FRGBɕϊăe[uɊi[
  				_EzError("o[Włxpmf[^̐FɐF(%ds)͎g܂B", i+1);
			}
		}
	}
	image_hdc = CreateCompatibleDC(win_hdc);
	assert(image_hdc != NULL);
	mask_hdc = CreateCompatibleDC(win_hdc);
	assert(mask_hdc != NULL);
	SelectObject(image_hdc, img.image);
	SelectObject(mask_hdc, img.mask);
	for (y = 0 ; y < img.height ; y ++){
		for (x = 0 ; x < img.width ; x ++){
			if (len == 1){
				c1 = xpm[y + color_num+1][x];
				c2 = 32;
			}
			else if (len == 2){
				c1 = xpm[y + color_num+1][x*2];
				c2 = xpm[y + color_num+1][x*2+1];
			}
			color = color_table[XpmChar2ColNo(c1, c2)];
			if (color == 0xffffffff){
				SetPixel(image_hdc, x, y, 0x000000);	
				SetPixel(mask_hdc, x, y, 0xffffff);	
			}
/*
			else if (color == 0){
				SetPixel(image_hdc, x, y, 0xff0000);	
			}
*/
			else {
				SetPixel(image_hdc, x, y, RGB2COLORREF(color));	
				SetPixel(mask_hdc, x, y, 0x00000);	
			}
		}
	}

	DeleteDC(image_hdc);
	DeleteDC(mask_hdc);
	return img;
}
#endif

void _EzXPMInitialize(void){
	enable_combined_bmp = _EzReadIniBool("XPM", "CombinedBMP", 1);
	xpm_bmp_max = _EzReadIniInt("XPM", "BMPMax", XPM_BMP_MAX_DEFAULT); 
	combined_bmp_size = _EzReadIniInt("XPM", "CombinedBMPSize", COMBINED_BMP_SIZE_DEFAULT); 
	if (xpm_bmp_max < 1) xpm_bmp_max = 1; // malloc邽ߍŒ1͕Kv 
	xpm_bmps = malloc(sizeof(xpm_bmp_t)*xpm_bmp_max);
	if (xpm_bmps == NULL){
		_EzError("%dxpm_bmp_tTCŸ̊mۂɎs܂B\n",
                 xpm_bmp_max);
	}
}
void _EzXPMTerminate(void){
    _EzDeleteImage();
    free(xpm_bmps);
}

void _EzDeleteImage(void){
	int i;
	for (i = 0 ; i < xpm_bmp_num ; i++){
		DeleteObject(xpm_bmps[i].bmp);
		DeleteObject(xpm_bmps[i].mask);
	}
}

void EzPut(int x, int y, EzImage img){
	if (!enableMagnify){
		_EzPut(win_hdc, x, y, img);
	}
	_EzPut(buf_hdc[onScreen], x, y, img);
}
void EzPutB(int x, int y, EzImage img){
	_EzPut(buf_hdc[offScreen], x, y, img);
}
void _EzPut(HDC hdc, int x, int y, EzImage img){
	HDC image_hdc, mask_hdc;

	image_hdc = CreateCompatibleDC(hdc);
	mask_hdc = CreateCompatibleDC(hdc);
	SelectObject(image_hdc, img.image);
	SelectObject(mask_hdc, img.mask);
#ifdef _EZ_COMBINED_BMP
	if (enable_combined_bmp){
		BitBlt(hdc, x, y, img.width, img.height, mask_hdc, 0, img.heightOffset, SRCAND);
		BitBlt(hdc, x, y, img.width, img.height, image_hdc, 0, img.heightOffset, SRCPAINT);
	}
	else {
		BitBlt(hdc, x, y, img.width, img.height, mask_hdc, 0, 0, SRCAND);
		BitBlt(hdc, x, y, img.width, img.height, image_hdc, 0, 0, SRCPAINT);
	}
#else
	BitBlt(hdc, x, y, img.width, img.height, mask_hdc, 0, 0, SRCAND);
	BitBlt(hdc, x, y, img.width, img.height, image_hdc, 0, 0, SRCPAINT);
#endif
	DeleteDC(image_hdc);
	DeleteDC(mask_hdc);
}

long EzGetTimeLeft(void){
	return timerh_nexttime - GetTickCount();
}

void _backSlash2Slash(char *str){
	while (*str != '\0'){
		if (*str == '\\'){
			*str = '/';
		}
        str ++;
	}
}

void _slash2BackSlash(char *str){
	while (*str != '\0'){
		if (*str == '/'){
			*str = '\\';
		}
        str ++;
	}
}

void _downcase(char *src, char *result){
	while (*src != '\0'){
		*result = tolower(*src);
		src ++;
		result ++;
	}
	*result = '\0';
}


int _EzPrintf(const char *fmt, ...){
	va_list ap;
	char buf[PRINTF_MAX_LEN+1];

	va_start(ap, fmt);
	vsprintf(buf, fmt, ap);
//	vsnprintf(buf, PRINTF_MAX_LEN, fmt, ap);
    va_end(ap);
	// o͓eӂꂽꍇARs[ɃI[oȂ悤AkĂ
	buf[PRINTF_MAX_LEN] = 0;
	return _EzPutLine(buf);
}

int _EzPuts(const char *s){
	char buf[PRINTF_MAX_LEN+1];

	if (strlen(s) >= PRINTF_MAX_LEN) return -1;

	sprintf(buf, "%s\n", s);
	return _EzPutLine(buf);
}


int _EzPutLine(char *line){
	char *src, *dest;
	// R\[EBhEJĂꍇ̂ݍĕ`v
	if (consoleHwnd){
		InvalidateRect(consoleHwnd, NULL, FALSE);   
	}
	src = line;
	dest = console_text[console_tail] + console_len;
	while (*src != '\0'){
		if (*src == '\n'){
			*dest = '\0';
		    console_tail = (console_tail + 1) % CONSOLE_LINES;
			console_len = 0;
			dest = console_text[console_tail];
			*dest = '\0';
			return 0;
		}
	    *dest = *src;
		src ++;
		dest ++;
		console_len ++;
		if (console_len == CONSOLE_LENGTH){
  		    console_text[console_tail][CONSOLE_LENGTH] = '\0';
		    console_tail = (console_tail + 1) % CONSOLE_LINES;
			console_len = 0;
			dest = console_text[console_tail];
		}
	}
	*dest = '\0';
	return 0;
}

int _EzLog(const char *msg){
	FILE *fp;
	char path[MAX_PATH];
	sprintf(path, "%s/%s", exeDir, LOG_FILENAME);
	fp = fopen(path, "a");
	if (fp == NULL) return -1;

	fputs(msg, fp);
	fputc('\n', fp);
	fclose(fp);
	return 0;
}

int _EzWarn(char *fmt, ...){
	va_list ap;
	char buf[PRINTF_MAX_LEN+1] = "Warning: ";

	va_start(ap, fmt);
	vsprintf(buf+strlen(buf), fmt, ap);
    va_end(ap);
	// o͓eӂꂽꍇARs[ɃI[oȂ悤AkĂ
	buf[PRINTF_MAX_LEN] = 0;
	return _EzLog(buf);
}
void _EzError(char *fmt, ...){
	va_list ap;
	char buf[PRINTF_MAX_LEN+1] = "Error: ";

	va_start(ap, fmt);
	vsprintf(buf+strlen(buf), fmt, ap);
    va_end(ap);
	// o͓eӂꂽꍇARs[ɃI[oȂ悤AkĂ
	buf[PRINTF_MAX_LEN] = 0;
	_EzLog(buf);
	SendMessage(win_hwnd, WM_DESTROY, 0, 0);
}

void _EzSaveStat(void){
	RECT wRect;
	GetWindowRect(win_hwnd, &wRect);
	_EzWriteIniInt("Window", "Left", wRect.left);
	_EzWriteIniInt("Window", "Top", wRect.top);
	_EzSaveIni();
}

void _EzLoadIni(void){
	char path[MAX_PATH];
	sprintf(path, "%s/%s", exeDir, INI_FILENAME);
	_EzLoadIniFile(path, 1);
}

void _EzLoadInf(void){
	char path[MAX_PATH];
	sprintf(path, "%s/%s", exeDir, INF_FILENAME);
	_EzLoadIniFile(path, 0);
}

void _EzLoadIniFile(char *path, int is_saved){
	FILE *fp;
//	ini_section_t *section;
	char buf[INI_BUF_SIZE];
	char section_name[INI_BUF_SIZE] = "";
	char *p, *value;
	int line = 0;

	fp = fopen(path, "r");
	if (fp == NULL){
		_EzWarn("%s݂܂B", path);
		return ;
	}
	while (fgets(buf, INI_BUF_SIZE, fp) != NULL){
		line ++;
		if (buf[0] == '0' || buf[0] == '\n' || buf[0] == '#'){
			continue;
		}
		if (sscanf(buf, "[%s", section_name) == 1){
			p = strchr(section_name, ']');
			if (p != NULL){
				*p = '\0';
                                //				_EzWarn("section:%s:", section_name);
			}
			else {
				_EzError("Illegal Line %d in %s", line, path);
				return;
			}
		}
		else if ((p = strchr(buf, '=')) != NULL){
			*p = '\0';
//			value = atoi(p+1);
			p++;
			value = p;
			while (*p != '\0'){
				p++;
			}
			*(p-1) = '\0'; // sR[hԂ
                        //			_EzWarn("key:%s, value:%d", buf, value);
			if (is_saved){
				_EzWriteIniString(section_name, buf, value);
			}
			else {
				_EzWriteIniStringNosave(section_name, buf, value);
			}
		}
		else {
			_EzError("Illegal Line %d in %s", line, path);
			return;
		}
	}
	fclose(fp);
}
void _EzSaveIni(void){
	FILE *fp;
	char path[MAX_PATH];
	int i, j;
	ini_section_t *section;



	sprintf(path, "%s/%s", exeDir, INI_FILENAME);
	fp = fopen(path, "w");
	if (fp == NULL){
		_EzWarn("INIt@Co܂B");
		return ;
	}
	fputs("# EzGraph INI file\n", fp);
	for (i = 0 ; i < ini_section_num ; i++){
		section = &ini_sections[i];
		if (section->saved_entry_num == 0) continue;
		fprintf(fp, "\n[%s]\n", section->name);
		for (j = 0 ; j < section->entry_num ; j++){
			if (section->entries[j].is_saved)
			fprintf(fp, "%s=%s\n", section->entries[j].key, section->entries[j].value);
		}
	}
	fclose(fp);
}

int _EzReadIniInt(char *section_name, char *key, int default_value){
	ini_section_t *section;
	char *ret;

	section = _EzGetIniSection(section_name);
	if (section == NULL) return default_value;

	ret = _EzReadIniEntry(section, key, NULL);
	if (ret) {
		return atoi(ret);
	}
	else {
		return default_value;
	}
}

int _EzReadIniBool(char *section_name, char *key, int default_value){
	ini_section_t *section;
	char *ret;

	section = _EzGetIniSection(section_name);
	if (section == NULL) return default_value;

	ret = _EzReadIniEntry(section, key, NULL);
	if (ret) {
		if (lstrcmpi(ret, "True") == 0 || lstrcmpi(ret, "Yes") == 0){
			return 1;
		}
		else if (lstrcmpi(ret, "False") == 0 || lstrcmpi(ret, "No") == 0){
			return 0;
		}
		else {
			_EzError("Illegal boolean value for %s:%s\n", section_name, key);
			return -1;
		}
	}
	else {
		return default_value;
	}
}

char *_EzReadIniString(char *section_name, char *key, char *default_value){
	ini_section_t *section;

	section = _EzGetIniSection(section_name);
	if (section == NULL) return default_value;

	return _EzReadIniEntry(section, key, default_value);
}

char *_EzReadIniEntry(ini_section_t *section, char *key, char *default_value){
	ini_entry_t *entry;

	entry = _EzGetIniEntry(section, key);
	if (entry == NULL) return default_value;
	return entry->value;
}

void _EzWriteIniInt(char *section_name, char *key, int value){
	ini_section_t *section;
	char buf[INI_VALUE_LEN_MAX];

	section = _EzGetIniSection(section_name);
	if (section == NULL){
		section = _EzCreateIniSection(section_name);
	}
	if (section != NULL){
		sprintf(buf, "%d", value);
		_EzWriteIniEntry(section, key, buf, 1);
	}
}
void _EzWriteIniIntNosave(char *section_name, char *key, int value){
	ini_section_t *section;
	char buf[INI_VALUE_LEN_MAX];

	section = _EzGetIniSection(section_name);
	if (section == NULL){
		section = _EzCreateIniSection(section_name);
	}
	if (section != NULL){
		sprintf(buf, "%d", value);
		_EzWriteIniEntry(section, key, buf, 0);
	}
}
void _EzWriteIniBool(char *section_name, char *key, int value){
	ini_section_t *section;

	section = _EzGetIniSection(section_name);
	if (section == NULL){
		section = _EzCreateIniSection(section_name);
	}
	if (section != NULL){
		_EzWriteIniEntry(section, key, value ? "True" : "False", 1);
	}
}
void _EzWriteIniBoolNosave(char *section_name, char *key, int value){
	ini_section_t *section;

	section = _EzGetIniSection(section_name);
	if (section == NULL){
		section = _EzCreateIniSection(section_name);
	}
	if (section != NULL){
		_EzWriteIniEntry(section, key, value ? "True" : "False", 0);
	}
}
void _EzWriteIniString(char *section_name, char *key, char *value){
	ini_section_t *section;

	section = _EzGetIniSection(section_name);
	if (section == NULL){
		section = _EzCreateIniSection(section_name);
	}
	if (section != NULL){
		_EzWriteIniEntry(section, key, value, 1);
	}
}
void _EzWriteIniStringNosave(char *section_name, char *key, char *value){
	ini_section_t *section;

	section = _EzGetIniSection(section_name);
	if (section == NULL){
		section = _EzCreateIniSection(section_name);
	}
	if (section != NULL){
		_EzWriteIniEntry(section, key, value, 0);
	}
}

void _EzWriteIniEntry(ini_section_t *section, char *key, char *value, int is_saved){
	ini_entry_t *entry;
	int len;

	entry = _EzGetIniEntry(section, key);
	if (entry == NULL){
		entry = _EzCreateIniEntry(section, key);
		if (is_saved){
			section->saved_entry_num ++;
		}
	}
	// ReadIniStringentryvalue𒼐ڎw|C^Ԃ̂ŁA
	// ̒lēxƂƃAhXdȂ
	// ̂memmoveg
	if (entry != NULL){
		len = strlen(value);
		memmove(entry->value, value, len+1);
		entry->is_saved = is_saved;
	}
}

ini_section_t *_EzGetIniSection(char *name){
	int i;
	for (i = 0 ; i < ini_section_num ; i++){
		if (lstrcmpi(name, ini_sections[i].name) == 0){
			return &ini_sections[i];
		}
	}
	return NULL;
}
ini_section_t *_EzCreateIniSection(char *name){
	if (ini_section_num >= INI_SECTION_MAX){
		_EzError("INIt@C̃ZNV𒴂܂B");
		return NULL;
	}
	strcpy(ini_sections[ini_section_num].name, name);
	ini_sections[ini_section_num].entry_num = 0;
	ini_sections[ini_section_num].saved_entry_num = 0;
	ini_section_num ++;
	return &ini_sections[ini_section_num-1];
}

ini_entry_t *_EzGetIniEntry(ini_section_t *section, char *key){
	int i;

	for (i = 0 ; i < section->entry_num ; i++){
		if (lstrcmpi(section->entries[i].key, key) == 0){
			return &section->entries[i];
		}
	}
	return NULL;
}


ini_entry_t *_EzCreateIniEntry(ini_section_t *section, char *key){
	if (section->entry_num >= INI_ENTRY_MAX){
		_EzError("INIt@CEZNV`%s'̃Gg𒴂܂B", section->name);
		return NULL;
	}
	strcpy(section->entries[section->entry_num].key, key);
	section->entries[section->entry_num].value[0] = '\0';
	section->entry_num ++;
	return &section->entries[section->entry_num-1];
}

void _EzShowSysInfo(void){
	_EzOpenModalWindow(CW_USEDEFAULT, CW_USEDEFAULT,
                       SYSINFO_WIDTH, SYSINFO_HEIGHT, _EzDrawSysInfo,
                       SYSINFO_CAPTION);
}
void _EzDrawSysInfo(HDC hdc, int width, int height){
	static char enableCombinedBMPStr[] = "Use combined BMPs        %3s";
	static char xpmBmpNumStr[]         = "BMPs for XPMs        %4d/%4d";
	static char combinedBMPSizeStr[]   = "BMP size         %8dkbytes";
	RECT rect = {8, 32, 0, 64+DIALOG_LINEPITCH};
	char buf[1024];
	UINT format = DT_BOTTOM;

	rect.right = width-8;
	sprintf(buf, enableCombinedBMPStr, enable_combined_bmp ? "Yes" : "No");
	DrawText(hdc, buf, -1, &rect, format); 
	rect.top +=  DIALOG_LINEPITCH;
	rect.bottom += DIALOG_LINEPITCH;
	sprintf(buf, xpmBmpNumStr, xpm_bmp_num, xpm_bmp_max);
	DrawText(hdc, buf, -1, &rect, format); 
	rect.top +=  DIALOG_LINEPITCH;
	rect.bottom += DIALOG_LINEPITCH;
	sprintf(buf, combinedBMPSizeStr, combined_bmp_size);
	DrawText(hdc, buf, -1, &rect, format); 
}


void _EzShowManual(void){
	char path[MAX_PATH];

	if (!applicationManual) return;
	sprintf(path, "%s/%s", exeDir, applicationManual);
	printf("show manual '%s'\n", path);
	ShellExecute(NULL, NULL, path, NULL, NULL, SW_SHOWNORMAL);
}
	
void _EzShowVersion(void){
	_EzOpenModalWindow(CW_USEDEFAULT, CW_USEDEFAULT, VERSION_WIDTH, VERSION_HEIGHT, _EzDrawVersion, VERSION_CAPTION);
}
void _EzDrawVersion(HDC hdc, int width, int height){
	static char libName[] = LIBNAME;
	static char libVersion[] = "Version %d.%d";
	RECT rect = {0, 32, 0, 64+DIALOG_LINEPITCH};
	char buf[1024];
	UINT format = DT_BOTTOM | DT_CENTER;

	rect.right = width-8;
	if (applicationName) DrawText(hdc, applicationName, -1, &rect, format); 
	rect.top +=  DIALOG_LINEPITCH;
	rect.bottom += DIALOG_LINEPITCH;
	if (applicationVendor) DrawText(hdc, applicationVendor, -1, &rect, format); 
	rect.top +=  DIALOG_LINEPITCH;
	rect.bottom += DIALOG_LINEPITCH;
	if (applicationVersion) DrawText(hdc, applicationVersion, -1, &rect, format); 
	rect.top +=  DIALOG_LINEPITCH+8;
	rect.bottom += DIALOG_LINEPITCH+8;
	DrawText(hdc, libName, -1, &rect, format); 
	rect.top +=  DIALOG_LINEPITCH;
	rect.bottom += DIALOG_LINEPITCH;
	sprintf(buf, libVersion, MAJOR_VERSION, MINOR_VERSION);
	DrawText(hdc, buf, -1, &rect, format); 
}

static void(*modalDrawFunc)(HDC hdc, int width, int height) = NULL;

void _EzOpenModalWindow(int left, int top, int width, int height, void(*draw_func)(HDC, int width, int height), char *caption){
	HINSTANCE hInstance;
	RECT wrect, crect;

	GetWindowRect(win_hwnd, &wrect);
	GetClientRect(win_hwnd, &crect);
	if (left == CW_USEDEFAULT){
		left = wrect.left + (crect.right-width)/2;
	}
	if (top == CW_USEDEFAULT){
		top = wrect.top + (crect.bottom-height)/2;
	}

    hInstance = (HINSTANCE)GetWindowLong(win_hwnd, GWL_HINSTANCE);
	modalDrawFunc = draw_func;
	dialogHwnd = CreateWindowEx(DIALOG_DWEXSTYLE, "EzGraphDialogClass", caption, 
		          			    DIALOG_DWSTYLE,
								left, top, width, height, win_hwnd, NULL, hInstance, NULL);
	// [__CAOۂ邽߃CER\[EBhE𑀍s
	// 
    EnableWindow(win_hwnd, FALSE);
	if (enableConsole){
	    EnableWindow(consoleHwnd, FALSE);
	}
	// ^C}Ƃ߂Ă
	dialog_timerh_func = timerh_func;
	timerh_func = NULL;
}


LRESULT CALLBACK DialogProc(HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
	PAINTSTRUCT ps;
    HDC hdc = NULL;
	HFONT hFont;
	static HWND hOkButton;
	HINSTANCE hInstance;
	RECT rect;
	HBRUSH hBrush;
	LOGFONT font;

	switch (message) {
	case WM_CREATE:
		hInstance = (HINSTANCE)GetWindowLong(win_hwnd, GWL_HINSTANCE);	
		GetClientRect(hwnd, &rect);
		hOkButton = CreateWindow("BUTTON", "OK",
								 WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
								 (rect.right-60)/2, rect.bottom-48, 60, DIALOG_LINEPITCH,
								 hwnd, NULL, hInstance, NULL);
		return 0;
	case WM_PAINT:
		if (modalDrawFunc){
		    memset(&font, 0, sizeof(font));
			// [U\[XShiftJisłƑz肵Ă̂ŁA
			// ShiftJisɐݒ肵Ȃƕ
			font.lfCharSet = SHIFTJIS_CHARSET;
			font.lfPitchAndFamily = FIXED_PITCH;
			font.lfHeight = DIALOG_FONTSIZE;
			hdc = BeginPaint(dialogHwnd, &ps);
			hFont = CreateFontIndirect(&font);
			SelectObject(hdc, &font);
			hBrush = CreateSolidBrush(GetSysColor(COLOR_WINDOW)); 
//			hBrush = CreateSolidBrush(GetSysColor(COLOR_GRAYTEXT)); 
            SelectObject(hdc, hBrush); 


			SetTextColor(hdc, GetSysColor(COLOR_WINDOWTEXT));	
			SetBkColor(hdc, GetSysColor(COLOR_WINDOW));
			SetBkMode(hdc, TRANSPARENT);

			GetClientRect(hwnd, &rect);
			FillRect(hdc, &rect, hBrush);
			modalDrawFunc(hdc, rect.right-rect.left, rect.bottom-rect.top);
			DeleteObject(hFont);
			EndPaint(dialogHwnd, &ps);
		}
		return 0;
	case WM_COMMAND:
		// sɂĂCER\[EBhE𑀍\ɂ
        EnableWindow(win_hwnd, TRUE);
		if (enableConsole){
		      EnableWindow(consoleHwnd, TRUE);
		}
		// ȂEBhEwɍsĂ܂̂ŁAgbvɈړĂ
		// Ԃsv
//		SetWindowPos(consoleHwnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
//		SetWindowPos(win_hwnd, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		timerh_func = dialog_timerh_func;
		// CEBhEANeBuEBhEɂȂ悤AWM_CLOSEM
		// EnableWindowōs
		SendMessage(hwnd, WM_CLOSE, 0, 0);
		return 0;
	case WM_DESTROY:
		modalDrawFunc = NULL;
		dialogHwnd = NULL;
		return 0;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}

